#!/bin/bash
# ------------------------------------------------------------------------------------
#
# Build either the full works, or the stripped down "busy_1" of RT firmwares
#
# ------------------------------------------------------------------------------------
if test "$1" = ""; then
   echo "Syntax = $0 <selection> [copy]"
   echo "Selection = \"full\" or or \"small\" or \"busy_1\""
   echo "\"copy\" = copy binary over to RouterTech /usr/local/bin/"
   exit 1
fi

if test "$1" != "full" && test "$1" != "busy_1" && test "$1" != "small" ; then
   echo "Ahem! Sorry, but I don't understand what you want to do."
   echo "Syntax = $0 <selection>"
   echo "Selection = \"full\" or or \"small\" or \"busy_1\""
   exit 1
fi

# which gcc version?
if test "$GCC_BASE" = "3.4.6"; then
   gcc_ver=3.4.6
else
   gcc_ver=4.1.2
fi

BASEDIR=/opt/gcc/ar7/staging_dir
CROSS_COMPILE=mipsel-uclibc
CFLAGS="-Os -s -ffunction-sections -fdata-sections"
#LDFLAGS="-Wl,--gc-sections"

# where to copy things
if test "$FILESYS_DIR" = ""; then
   FILESYS_DIR=../../filesystem
fi

# --- fix the paths
export PATH=$PATH:$BASEDIR/toolchain-mipsel_gcc$gcc_ver/bin
# export C_INCLUDE_PATH=$BASEDIR/toolchain-mipsel_gcc$gcc_ver/include:/opt/toolchain-mipsel_gcc$gcc_ver/lib/gcc/mipsel-linux-uclibc/$gcc_ver/include

AS=$CROSS_COMPILE-as
LD=$CROSS_COMPILE-ld
RANLIB=$CROSS_COMPILE-ranlib
CPP="$CROSS_COMPILE-gcc -E"
AR=$CROSS_COMPILE-ar
NM=$CROSS_COMPILE-nm
STRIP=$CROSS_COMPILE-strip
OBJCOPY=$CROSS_COMPILE-objcopy
OBJDUMP=$CROSS_COMPILE-objdump
HOSTCC=/usr/bin/gcc
export AS LD CC CPP AR NM STRIP OBJCOPY OBJDUMP CFLAGS RANLIB LDFLAGS

make distclean
rm -rf ./_install/

if test "$1" = "full"; then
   cp dot-config-full-firmware .config
fi

if test "$1" = "small"; then
   cp dot-config-small-firmware .config
fi

if test "$1" = "busy_1"; then
   cp dot-config-small-busy_1 .config
fi

make menuconfig
#make CC=$CROSS_COMPILE-gcc HOSTCC=/usr/bin/gcc STRIP=$CROSS_COMPILE-strip
#make CC=$CROSS_COMPILE-gcc HOSTCC=/usr/bin/gcc STRIP=$CROSS_COMPILE-strip install
make CC=$CROSS_COMPILE-gcc HOSTCC=/usr/bin/gcc STRIP=$CROSS_COMPILE-strip CONFIG_PREFIX=$FILESYS_DIR PREFIX=$FILESYS_DIR
chmod 0755 ./busybox
make CC=$CROSS_COMPILE-gcc HOSTCC=/usr/bin/gcc STRIP=$CROSS_COMPILE-strip CONFIG_PREFIX=$FILESYS_DIR PREFIX=$FILESYS_DIR install
chmod 0755 $FILESYS_DIR/bin/busybox

if test -e "./busybox"; then

# ---  the next few lines are specific to RT firmwares
  rm -f $FILESYS_DIR/sbin/reboot
#  ln -s -f /usr/local/bin/reboot.sh $FILESYS_DIR/sbin/reboot
  cp -f -a ./reboot.sh $FILESYS_DIR/sbin/reboot
  cp -f -a ./cmcli $FILESYS_DIR/usr/bin
# ----

 if test "$1" = "full"; then
   cp .config dot-config-full-firmware
 fi

 if test "$1" = "small"; then
   cp .config dot-config-small-firmware
 fi

 if test "$1" = "busy_1"; then
   cp .config dot-config-small-busy_1
 fi
fi

# copy
if test "$1" = "busy_1" && test "$2" = "copy"; then
   cp -a busybox ~/router/RouterTech_Firmware/nsp/usr.wrd/local/bin/busy_1
   cp -a busybox ~/router/RouterTech_Firmware/nsp/usr.ar7rd/local/bin/busy_1
fi
