.PHONY: dummy

first_rule: sub_dirs all_targets

-include $(TOPDIR)/.config

# board specific defines
ifeq ($(BOARD),AR7RD)
BOARD_HAS_DSL=y
endif

ifeq ($(BOARD),AR7WRD)
BOARD_HAS_DSL=y
endif

ifeq ($(BOARD),AR7VWI)
BOARD_HAS_DSL=y
endif

ifeq ($(BOARD),AR7VW)
BOARD_HAS_DSL=y
endif

ifeq ($(BOARD),AR7WI)
BOARD_HAS_DSL=y
endif

ifeq ($(BOARD),AR7V)
BOARD_HAS_DSL=y
endif

ifeq ($(BOARD),WA123)
BOARD_HAS_DSL=n
BOARD_HAS_MARVELL=y
else
BOARD_HAS_MARVELL=$(CONFIG_MIPS_AVALANCHE_MARVELL)
endif

BOARD_HAS_WLAN=$(CONFIG_TI_WLAN)
BOARD_HAS_VOICE=$(CONFIG_TI_VOICEAPP)
BOARD_HAS_CPMAC=$(CONFIG_MIPS_AVALANCHE_CPMAC)
BOARD_HAS_VMAC=$(CONFIG_MIPS_AVALANCHE_VMAC)



ifeq ($(CONFIG_MIPS_AVALANCHE_USB),m)
BOARD_HAS_USB=y
endif

ifeq ($(CONFIG_TI_CFGMGR_LOCAL_PROVISION),y)
BOARD_HAS_LOCAL=y
endif

#default if no size defined
FLASH_SIZE=4

ifeq ($(CONFIG_ADAM2_16M),y)
FLASH_SIZE=4
endif

ifeq ($(CONFIG_ADAM2_8M),y)
FLASH_SIZE=2
endif

ifeq ($(CONFIG_PSPBOOT_MEM_2M_8M),y)
FLASH_SIZE=2
endif

ifeq ($(CONFIG_PSPBOOT_MEM_4M_16M),y)
FLASH_SIZE=4
endif

ifeq ($(CONFIG_PSPBOOT_MEM_8M_32M),y)
FLASH_SIZE=8
endif


BOARD_HAS_ONEIMAGE=y

cflags-$(BOARD_HAS_DSL) += -DBOARD_HAS_DSL
cflags-$(BOARD_HAS_WLAN) += -DBOARD_HAS_WLAN -I$(TOPDIR)/../wlan/src/os/linux -DCONFIG_NET_RADIO -DWE_NOLIBM
cflags-$(BOARD_HAS_VOICE) += -DBOARD_HAS_VOICE
cflags-$(BOARD_HAS_MARVELL) += -DBOARD_HAS_MARVELL
cflags-$(BOARD_HAS_USB) += -DBOARD_HAS_USB
cflags-$(BOARD_HAS_CPMAC) += -DBOARD_HAS_CPMAC
cflags-$(BOARD_HAS_VMAC) += -DBOARD_HAS_VMAC
cflags-$(BOARD_HAS_LOCAL) += -DBOARD_HAS_LOCAL
cflags-$(BOARD_HAS_ONEIMAGE) += -DBOARD_HAS_ONEIMAGE
cflags-$(CONFIG_TI_VOICE_MGCP) += -DCONFIG_TI_VOICE_MGCP
cflags-$(CONFIG_TI_VOICE_SIP) += -DCONFIG_TI_VOICE_SIP
cflags-$(CONFIG_TI_VOICE_DIMTEST) += -DCONFIG_TI_VOICE_DIMTEST
cflags-$(CONFIG_TI_VOICE_GGBASICA) += -DCONFIG_TI_VOICE_GGBASICA
cflags-$(CONFIG_TI_VOICE_GGSVCA) += -DCONFIG_TI_VOICE_GGSVCA
cflags-$(CONFIG_TI_SYS_EVENTS) += -DCONFIG_TI_SYS_EVENTS
cflags-$(CONFIG_TI_TR069) += -DCONFIG_TI_TR069
cflags-$(CONFIG_TI_WT104) += -DCONFIG_TI_WT104
cflags-$(CONFIG_TI_TR069) += -DHAS_COOKIE_CODE
cflags-$(CONFIG_TI_CFGMGR_SNMP) += -DCONFIG_TI_CFGMGR_SNMP
cflags-$(CONFIG_TI_CFGMGR_SNTP) += -DCONFIG_TI_CFGMGR_SNTP
cflags-$(CONFIG_TI_CFGMGR_UPNP) += -DCONFIG_TI_CFGMGR_UPNP
cflags-$(CONFIG_TI_CFGMGR_DHCPFWD) += -DCONFIG_TI_CFGMGR_DHCPFWD
cflags-$(CONFIG_TI_CFGMGR_DDNSCLIENT) += -DCONFIG_TI_CFGMGR_DDNSCLIENT
cflags-$(CONFIG_TI_NETKIT_ROUTEDV2) += -DCONFIG_TI_NETKIT_ROUTEDV2
cflags-$(CONFIG_ATM_CLIP) += -DCONFIG_ATM_CLIP






# general
SUB_DIRS = $(subdir-y)
CFLAGS += $(cflags-y) -DBOARD_$(BOARD) -DVERSION=\"$(CONFIG_TI_NSP_VERSION)\" -DHAS_COOKIE_CODE -DFLASH_SIZE=$(FLASH_SIZE)
#CFLAGS += -DCOMPLY_2WIRE
#CFLAGS += -DCOMPLY_MOTIVE
#CFLAGS += -DCOMPLY_CISCO
LDFLAGS += $(ldflags-y)
SRCDIR = $(TOPDIR)/src
INCLUDE = $(SRCDIR)/include
CMLIBDIR = $(SRCDIR)/lib
INCEXPAT = $(TOPDIR)/expat
LIBEXPAT = $(TOPDIR)/expat
ZLIBDIR = $(TI_base)$(TI_rlibdir)
AR=ar
RANLIB=ranlib

CFLAGS += -I$(INCLUDE) -I$(INCEXPAT) -I$(TOPDIR)/../events/include -Wall
LDFLAGS += -L$(CMLIBDIR) -L$(LIBEXPAT) -L$(ZLIBDIR)

ifndef BOARD_HAS_WLAN
CONFIG_TI_CFGMGR_AP=n
endif

# memory debugging
ifeq ($(CONFIG_TI_DMALLOC),y)
DMALLOC=y
CFLAGS += -g -DDMALLOC -I$(TOPDIR)/../dmalloc
LDEXTRA += -ltidmalloc
else
CFLAGS += -Os
endif

# main directory list
subdir-list = $(patsubst %, _subdir_%, $(SUB_DIRS))
sub_dirs: dummy $(subdir-list)

ifdef SUB_DIRS
$(subdir-list) : dummy
	@ $(MAKE) -C $(patsubst _subdir_%,%,$@) BOARD=$(BOARD)
endif

# dependency directory list
dep-subdir-list = $(patsubst %, dep_subdir_%, $(SUB_DIRS))
dep-sub_dirs: dummy $(dep-subdir-list)

ifdef SUB_DIRS
$(dep-subdir-list) : dummy
	@ $(MAKE) -C $(patsubst dep_subdir_%,%,$@) dep
endif

SRC_FILES=$(shell ls *.c 2> /dev/null)

dep-files-list = $(patsubst %, dep_file_%, $(SRC_FILES))
dep-files: emptydep $(dep-files-list)

emptydep:
	@ > .depend

ifdef SRC_FILES
$(dep-files-list) : dummy
	@ $(CC) $(CFLAGS) -MM $(patsubst dep_file_%,%,$@) >> .depend
endif

dep: dep-sub_dirs dep-files

# all binary targets
all_targets: $(O_TARGET) $(SO_TARGET) $(A_TARGET) $(TARGET)

ifdef O_TARGET
ifdef obj-y
$(O_TARGET) : $(obj-y)
	rm -f $@
	$(LD) -r -o $@ $(filter $(obj-y), $^) $(LDFLAGS)
endif
endif

ifdef TARGET
ifdef obj-y
$(TARGET) : $(obj-y)
	rm -f $@
	$(CC) -o $@ $(filter $(obj-y), $^) $(LDFLAGS) $(LDEXTRA)
endif
endif

ifdef A_TARGET
ifdef obj-y
$(A_TARGET): $(obj-y)
	rm -f $@
	$(AR) rc $@ $(filter $(obj-y), $^)
	$(RANLIB) $@
endif
endif

ifdef SO_TARGET
ifdef obj-y
$(SO_TARGET): $(obj-y)
	rm -f $@
	$(CC) -shared -o $@ $(filter $(obj-y), $^) $(LDFLAGS) $(LDEXTRA)
endif
endif

# clean
clean:
	find . \( -name '*.[oas]' -o -name core -o -name '*~' -o -name '.*~' -o -name '.#*' -o -name '*.so' \) -type f -print | xargs rm -f

deep-clean: clean
	find . \( -name '.depend' \) -type f -print | xargs rm -f
	find . \( -name 'cm_logic' -o -name 'cm_pc' -o -name 'cm_monitor' -o -name 'cm_cli' -o -name 'snmpd' \) -type f -perm +111 -print | xargs rm -f

dummy:

ifneq ($(wildcard .depend),)
include .depend
endif
