#!/bin/bash -x
# ------------------------------------
#
# RouterTech GPL release; script to install some RouterTech extras
#
# ------------------------------------

# where to copy things - default, if none is supplied in the calling Makefile
if test "$FILESYS_DIR" = ""; then
   FILESYS_DIR=../../filesystem
fi

# where to install it to
if test "$DEST_DIREC" = ""; then
   DEST_DIREC=$FILESYS_DIR/usr/local/bin
fi

# general stuff

# cron doesn't exist in standard busybox
if ! test "$CONFIG_ROUTERTECH_EXTRAS" = ""; then
   cp -a ./cron_init.sh $DEST_DIREC
fi

# the rest
mkdir -p $DEST_DIREC
cp -a ./getenv $DEST_DIREC
cp -a ./printenv $DEST_DIREC
cp -f -a ./cmcli $FILESYS_DIR/usr/bin
cp -f -a ./scp $FILESYS_DIR/usr/bin
cp -f -a ./groups $FILESYS_DIR/usr/bin
cp -f -a ./sft $FILESYS_DIR/usr/bin
cp -f -a ./sft_start.sh $FILESYS_DIR/usr/bin
tar -jxf RT_etc.tar.bz2 -C $FILESYS_DIR/

# etc/ppp stuff
if [ ! -d $FILESYS_DIR/etc/ppp ] ; then
   mkdir -p $FILESYS_DIR/etc/ppp
fi

ln -f -s /var/tmp/ppp_options $FILESYS_DIR/etc/ppp/options
ln -f -s /var/tmp/ppp_ip-up $FILESYS_DIR/etc/ppp/ip-up
ln -f -s /var/tmp/ppp_ip-down $FILESYS_DIR/etc/ppp/ip-down
ln -f -s /var/tmp/ppp_auth-up $FILESYS_DIR/etc/ppp/auth-up
ln -f -s /var/tmp/ppp_auth-down $FILESYS_DIR/etc/ppp/auth-down

# mount directory for CIFS
if [ ! -d $FILESYS_DIR/cifs ] ; then
   mkdir -p $FILESYS_DIR/cifs
fi

# mount directory for Minix
if [ ! -d $FILESYS_DIR/nvram ] ; then
   mkdir -p $FILESYS_DIR/nvram
fi

