/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/

#include <pal.h>

/*******************************************************************************
 * FUNCTION:    PAL_sysProbeAndPrep
 *******************************************************************************
 * DESCRIPTION: Function to get availablity of hardware in run-time
 *
 * RETURNS:     0: Yes, -1: No.
 *
 * NOTES: This function can be enhanced for more hardware devices in the future
 *
 ******************************************************************************/
PAL_Result PAL_sysProbeAndPrep(Uint32 module_version, Uint32 base_addr, Uint32 ptr)
{
  switch ( module_version )
  {
     case HARDWARE_USB_SLAVE:
        return -1;    
     case HARDWARE_CPMAC0:
        break;
     case HARDWARE_CPMAC1:
        break;
     case HARDWARE_ESWITCH:
        return -1;    
     case HARDWARE_LCD:
        return -1;    
     default:
        return -1;
  }     
  
  return 0;
}
