/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/

/*******************************************************************************
 * FILE PURPOSE:    Flash operations header
 *******************************************************************************
 * FILE NAME:       flashop.h
 *
 * DESCRIPTION:     Flash operations header
 *
 ******************************************************************************/

#ifndef	_FLASHOP_is1050_16_H_
#define	_FLASHOP_is1050_16_H_

#ifdef _STANDALONE
#include <psbl/stddef.h>
#else
#include "stddef.h"
#endif


int INTELFWBGetBlockSize(unsigned int base);           /*Get Flash Block Size            */
int INTELFWBErase(unsigned int base,int size,int verbose); /*Erase flash                     */
int INTELFWBOpen(unsigned int base);                   /*Prepare for flash writes        */
int INTELFWBWriteByte(unsigned int adr, char cVal);    /*Write byte to flash             */
int INTELFWBClose(void);                         /*Write any pending data to flash */
int INTELFWBUnLock(unsigned int adr,int size);       /*Unlock Flash block(s)           */
int INTELFWBLock(unsigned int from,int size);        /*Lock Flash block(s)             */

int INTELFWBGet_flash_type(void); /* Valid for dual flash boards */

unsigned int INTELFWBGetNextBlock(unsigned int base);  /* Get base addr of next block    */

       
#endif /* _FLASHOP_is1050_16_H_ */

