#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/proc_fs.h>
#include <linux/string.h>
#include <linux/vmalloc.h>
#include <asm/uaccess.h>

#define MAX_CHIEF_MTD_LENGTH 64
static char chief_mtd_var[MAX_CHIEF_MTD_LENGTH];  // Space for chips_mtd strings
static struct chief_mtd_proc_dir_entry *proc_entry;

ssize_t chips_mtd_write ( struct file *filp, const char __user *buff, unsigned long len, void *data )
{
  if (copy_to_user( &chief_mtd_var[0], buff, len )) 
  {
    return -EFAULT;
  }
  return len;
}


int chips_mtd_read ( char *page, char **start, off_t off, int count, int *eof, void *data )
{
  int len;
  if (off > 0) 
  {
   *eof = 1;
    return 0;
  }
  len = sprintf (page, "%s\n", &chief_mtd_var[0]);
  return len;
}


int write_chip_mfr (char *entry)
{
int ret = 0;
/*
  chief_mtd_var = (char *)vmalloc( MAX_CHIEF_MTD_LENGTH );
  if (!chief_mtd_var) 
  {
    return -ENOMEM;
  } 
  else 
  {
     memset ( &chief_mtd_var, 0, MAX_CHIEF_MTD_LENGTH );
 */ 
     strcpy (&chief_mtd_var, entry);
     proc_entry = create_proc_entry( "chips_mtd", 0644, NULL );
     if (proc_entry == NULL) 
     {
       printk (KERN_INFO "chips_mtd: Couldn't create proc entry\n");
//       vfree (chief_mtd_var);
       return -ENOMEM;
     } 
     else 
     {
      proc_entry->read_proc = chips_mtd_read;
      proc_entry->write_proc = chips_mtd_write;
      proc_entry->owner = THIS_MODULE;
//      printk (KERN_INFO "chips_mtd: Module loaded.\n");
     }
//  }
  return ret;
}


static int init_mtd_chief_ext ( void )
{
     int ret = 0;
     memset ( &chief_mtd_var, 0, MAX_CHIEF_MTD_LENGTH );
     proc_entry = create_proc_entry( "chips_mtd", 0644, NULL );
     if (proc_entry == NULL) 
     {
       printk (KERN_INFO "chips_mtd: Couldn't create proc entry\n");
       return -ENOMEM;
     } 
     else 
     {
      proc_entry->read_proc = chips_mtd_read;
      proc_entry->write_proc = chips_mtd_write;
      proc_entry->owner = THIS_MODULE;
      printk (KERN_INFO "chips_mtd: Module loaded.\n");
     }
  return ret;
}

static void exit_mtd_chief_ext ( void )
{
//  remove_proc_entry ("fortune", &proc_root);
//  printk (KERN_INFO "fortune: Module unloaded.\n");
}

module_init(init_mtd_chief_ext);
module_exit(exit_mtd_chief_ext);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("The African Chief <www.routertech.org>");
MODULE_DESCRIPTION("Extension to store flash chip manufacturer details.");
