/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/

/******************************************************************************
 * FILE NAME    :  usb20_state.c  
 *
 * DESCRIPTION  :  Implements USB20 Driver State Machine
 *
 * HISTORY 	:  
 *
 * 	Aug 05  -  sabyasachi  -  created. 
 *
 *****************************************************************************/

#include "usb20_state.h"

static INT32  usb20_state;  /* The state machine */

INT32 usb_drv_state_init()
{
    USB_ENTER;
    usb20_state = USB20_DRV_STATE_DETACHED;
    USB_EXIT;
    return 0;
}

INT32 usb_drv_set_state(UINT32 state)
{
    USB_ENTER;
    if ( state >= USB20_DRV_STATE_DETACHED && state <= USB20_DRV_STATE_CONFIGURED )
        usb20_state = state;
    else 
	 return -1;
    USB_EXIT;
    return usb20_state;
}

INT32 usb_drv_get_state()
{
    USB_ENTER;
    USB_EXIT;
    return usb20_state;
}

INT32 usb_drv_state_shutdown()
{
    USB_ENTER;
    usb20_state = USB20_DRV_STATE_DETACHED;
    USB_EXIT;
    /* nothing to do as of now */
    return 0;
}

