/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/


/*******************************************************************************
 * FILE PURPOSE:    Graphical LCD Driver and Window Manager Stack Source
 *******************************************************************************
 * FILE NAME:       glcd_status.h
 *
 * DESCRIPTION:     Graphical LCD HAL, Display Driver and Winmgr Status file
 *
 * REVISION HISTORY:
 * 09-04-2004      Nakshatra     Initial creation
 *
 * (C) Copyright 2004, Texas Instruments, Inc
 ******************************************************************************/

#ifndef __GLCD_STATUS_H__
#define __GLCD_STATUS_H__

#ifndef _STANDALONE
#include <haltypes.h>
#else
typedef int INT32;
typedef unsigned int   UINT32;
typedef unsigned short UINT16;
typedef unsigned char  UINT8;

#define TRUE  1
#define FALSE 0
/*#define NULL  0*/
#endif

typedef enum GRAHPICS_STATUS {
	STATUS_SUCCESS = 0,
	STATUS_FAILURE = -1,
	STATUS_ERROR   = -2,
	STATUS_ERR_VIDEO_UNAVAIL = -3,
	STATUS_ERR_COORD_INVALID = -4,
	STATUS_ERR_UNKNOWN_CMD = -5,
} GRAHPICS_STATUS_T;

#endif __GLCD_STATUS_H__
