/*
 *  Copyright (C) 2005 Texas Instruments, Inc.  All rights reserved.
 *
 *  This program is free software; you can distribute it and/or modify it
 *  under the terms of the GNU General Public License (Version 2) as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 */

/*******************************************************************************
 * FILE PURPOSE:    Graphical LCD Configuration file
 *******************************************************************************
 * FILE NAME:       optrex_mono.h
 *
 * DESCRIPTION:     Configuration file for Optrex F-51477GNF-SLY-AA GLCD
 *
 * AUTHOR:			hai@ti.com
 *
 * (C) Copyright 2005, Texas Instruments, Inc
 ******************************************************************************/

static const DISPLAY_PANEL_T disp_panel = 
{
	QVGA,
	4,
	4,
	QVGA_WIDTH,  /* width          */
	QVGA_HEIGHT, /* height         */
    MONOCROME,
};

static const LCD_CNTRL_CONFIG_T lcd_cfg = 
{
	&disp_panel, /* p_disp_panel   */
	255,  /* hfp            */
	255,  /* hbp            */
	63,   /* hsw            */
	7,    /* vfp            */
	7,    /* vbp            */
	7,    /* vsw            */
	255,  /* ac bias        */
	0,    /* ac bias intrpt */
	16,   /* dma_burst_sz   */
	4,    /* bpp            */
	255,  /* fdd            */
	1,    /* lcd_clk        */
	7,    /* pxl_clk        */
    0,    /* tft_alt_mode   */
    0,    /* stn_565_mode   */
    0,    /* mono_8bit_mode    */
    0,    /* invert_pxl_clock  */
    0,    /* invert_line_clock */
    0,    /* invert_frm_clock  */
    0,    /* sync_edge         */
    0,    /* sync_ctrl         */
    0,    /* raster_order      */ 
};
