/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/

#ifndef _APEX_BOARDS_H
#define _APEX_BOARDS_H

// Let us define board specific information here. 

#if defined(CONFIG_MIPS_APEX) || defined(TNETV1020)
#define XTAL1_FREQ                                  25000000
#define XTAL2_FREQ                                  25000000
#define OSC_FREQ                                    25000000
#if defined(TNETV1020VDB) || defined(CONFIG_MIPS_APEX_1020VDB)
#define AVALANCHE_LOW_CPMAC_PHY_MASK                0x00000002
#define AVALANCHE_HIGH_CPMAC_PHY_MASK               0x00007800  
#else
#define AVALANCHE_LOW_CPMAC_PHY_MASK                0x00007800
#define AVALANCHE_HIGH_CPMAC_PHY_MASK               0xffffffff /* Only applicable to 115 VAG. We need to edit this for other boards. */
#endif
#define AVALANCHE_LOW_CPMAC_HAS_EXT_SWITCH          0
#define AVALANCHE_HIGH_CPMAC_HAS_EXT_SWITCH         1
#define AVALANCHE_NUM_VLYNQ_HOPS_PER_ROOT           1

#define VLYNQ_TNETW1150_MEM_OFFSET 0x00000000  /* Physical address of TNETW1150 memory */
#define VLYNQ_TNETW1150_MEM_SIZE   0x00080000  /* Total size of the TNETW1150 memory   */
#define VLYNQ_TNETW1150_REG_OFFSET 0x00300000  /* PHYS_ADDR of TNETW1150 control registers   */
#define VLYNQ_TNETW1150_REG_SIZE   0x00100000  /* Size of TNETW1150 registers area, MAC+PHY  */
#define TNETW1150_VL1_REMOTE_SIZE  0x04000000
#define TNETW1150_TX_MAP           0x60000000   /* Window start address into APEX */

#endif

#define VLYNQ0_RESET_GPIO_NUM                       13

#if defined CONFIG_MIPS_SEAD2
#define AVALANCHE_LOW_CPMAC_PHY_MASK                0xAAAAAAAA
#define AVALANCHE_HIGH_CPMAC_PHY_MASK               0x55555555
#define AVALANCHE_LOW_CPMAC_HAS_EXT_SWITCH          0
#define AVALANCHE_HIGH_CPMAC_HAS_EXT_SWITCH         0
#include <asm/mips-boards/sead.h>
#endif


#endif
