#ifndef _IPT_MIFNETS_H
#define _IPT_MIFNETS_H
#include <linux/netfilter_ipv4/ip_tables.h>

#define IPT_MIFNETS_IF_NUM 4
#define IPT_MIFNETS_INCLNET_NUM 8
#define IPT_MIFNETS_EXCLNET_NUM 8

#define IPT_MIFNETS_IFS			0x1
#define IPT_MIFNETS_INCLNETS	0x2
#define IPT_MIFNETS_EXCLNETS	0x4
#define IPT_MIFNETS_DPRIV		0x8
#define IPT_MIFNETS_NETS		(IPT_MIFNETS_INCLNETS|IPT_MIFNETS_EXCLNETS)
#define IPT_MIFNETS_ALL			(IPT_MIFNETS_IFS |IPT_MIFNETS_NETS|IPT_MIFNETS_DPRIV)

struct mifnets_net {
	u_int32_t addr;
	u_int32_t mask;
};

struct ipt_mifnets
{
    int 	flag;
    char 	ifnames[IPT_MIFNETS_IF_NUM][IFNAMSIZ];
    int 	name_len[IPT_MIFNETS_IF_NUM];
    struct mifnets_net incl_subnets[IPT_MIFNETS_INCLNET_NUM];      /* Source IP address */	
    struct mifnets_net excl_subnets[IPT_MIFNETS_EXCLNET_NUM];      /* Source IP address */    
    u_int8_t incl_count;                         /* Number of inclusive nets */
    u_int8_t excl_count;                        /* Number of exclusive nets */
    u_int8_t if_count;
};


#endif /* _IPT_MIP_ECNET_H */
    
     
