#*******************************************************************************
#*+--------------------------------------------------------------------------+**
#*|                            ****                                          |**
#*|                            ****                                          |**
#*|                            ******o***                                    |**
#*|                      ********_///_****                                   |**
#*|                      ***** /_//_/ ****                                   |**
#*|                       ** ** (__/ ****                                    |**
#*|                           *********                                      |**
#*|                            ****                                          |**
#*|                            ***                                           |**
#*|                                                                          |**
#*|         Copyright (c) 1998-2003 Texas Instruments Incorporated           |**
#*|                        ALL RIGHTS RESERVED                               |**
#*|                                                                          |**
#*| Permission is hereby granted to licensees of Texas Instruments           |**
#*| Incorporated (TI) products to use this computer program for the sole     |**
#*| purpose of implementing a licensee product based on TI products.         |**
#*| No other rights to reproduce, use, or disseminate this computer          |**
#*| program, whether in part or in whole, are granted.                       |**
#*|                                                                          |**
#*| TI makes no representation or warranties with respect to the             |**
#*| performance of this computer program, and specifically disclaims         |**
#*| any responsibility for any damages, special or consequential,            |**
#*| connected with the use of this program.                                  |**
#*|                                                                          |**
#*+--------------------------------------------------------------------------+**
#*******************************************************************************

# ******************************************************************************
# * FILE PURPOSE:    PSP Bootloader kernel Makefile
# ******************************************************************************
# * FILE NAME:       Makefile
# *
# * DESCRIPTION:     PSP Bootloader command Makefile
# *
# * (C) Copyright 2003, Texas Instruments, Inc
# ******************************************************************************

ifeq  ($(CONF_OCMD_REBOOT), YES)
SRCS_CMD_C 		+= reboot.c
endif
ifeq  ($(CONF_OCMD_VERSION), YES)
SRCS_CMD_C 		+= version.c
endif
ifeq  ($(CONF_OCMD_INFO), YES)
SRCS_CMD_C 		+= info.c
endif
ifeq  ($(CONF_OCMD_FA), YES)
SRCS_CMD_C 		+= fa.c
endif
ifeq  ($(CONF_OCMD_PRINTENV), YES)
SRCS_CMD_C 		+= printenv.c
endif
ifeq  ($(CONF_OCMD_SETENV), YES)
SRCS_CMD_C 		+= setenv.c
endif
ifeq  ($(PERMANENT_VARIABLES), YES)
ifeq  ($(CONF_OCMD_SETPERENV), YES)
SRCS_CMD_C 		+= setpenv.c
endif
endif
ifeq  ($(CONF_OCMD_UNSETENV), YES)
SRCS_CMD_C 		+= unsetenv.c
endif
ifeq  ($(CONF_OCMD_DEFRAGENV), YES)
SRCS_CMD_C 		+= defragenv.c
endif
ifeq  ($(CONF_OCMD_FMT), YES)
SRCS_CMD_C 		+= fmt.c
endif
ifeq  ($(CONF_OCMD_BOOT), YES)
SRCS_CMD_C 		+= boot.c
endif
ifeq  ($(CONF_OCMD_DM), YES)
SRCS_CMD_C 		+= dm.c
endif
ifeq  ($(CONF_OCMD_OCLK), YES)
SRCS_CMD_C 		+= oclk.c
endif
ifeq  ($(CONF_OCMD_HELP), YES)
SRCS_CMD_C 		+= help.c
endif

ifeq ($(FFS), YES)
ifeq  ($(CONF_OCMD_LS), YES)
SRCS_CMD_C 		+= ls.c
endif
ifeq  ($(CONF_OCMD_DF), YES)
SRCS_CMD_C 		+= df.c
endif
ifeq  ($(CONF_OCMD_CP), YES)
SRCS_CMD_C 		+= cp.c
endif
ifeq  ($(CONF_OCMD_CAT), YES)
SRCS_CMD_C 		+= cat.c
endif
ifeq  ($(CONF_OCMD_RM), YES)
SRCS_CMD_C 		+= rm.c
endif
endif	# FFS == YES

ifeq ($(NETWORK_VEHICLE), FTP)
ifeq  ($(CONF_OCMD_FTP), YES)
SRCS_CMD_C 		+= ftp.c
endif
endif # NETWORK_VEHICLE == FTP 

ifeq ($(NETWORK_VEHICLE), TFTP)
ifeq  ($(CONF_OCMD_TFTP), YES)
SRCS_CMD_C 		+= tftp_cmd.c
endif
endif # NETWORK_VEHICLE == TFTP 

