#*******************************************************************************
#*+--------------------------------------------------------------------------+**
#*|                            ****                                          |**
#*|                            ****                                          |**
#*|                            ******o***                                    |**
#*|                      ********_///_****                                   |**
#*|                      ***** /_//_/ ****                                   |**
#*|                       ** ** (__/ ****                                    |**
#*|                           *********                                      |**
#*|                            ****                                          |**
#*|                            ***                                           |**
#*|                                                                          |**
#*|         Copyright (c) 1998-2003 Texas Instruments Incorporated           |**
#*|                        ALL RIGHTS RESERVED                               |**
#*|                                                                          |**
#*| Permission is hereby granted to licensees of Texas Instruments           |**
#*| Incorporated (TI) products to use this computer program for the sole     |**
#*| purpose of implementing a licensee product based on TI products.         |**
#*| No other rights to reproduce, use, or disseminate this computer          |**
#*| program, whether in part or in whole, are granted.                       |**
#*|                                                                          |**
#*| TI makes no representation or warranties with respect to the             |**
#*| performance of this computer program, and specifically disclaims         |**
#*| any responsibility for any damages, special or consequential,            |**
#*| connected with the use of this program.                                  |**
#*|                                                                          |**
#*+--------------------------------------------------------------------------+**
#*******************************************************************************

# ******************************************************************************
# * FILE PURPOSE:    PSP Bootloader kernel Makefile
# ******************************************************************************
# * FILE NAME:       Makefile
# *
# * DESCRIPTION:     PSP Bootloader kernel Makefile, DO NOT MODIFY!
# *                  Different flash devices can be configured in bootcfg.mak
# *
# * (C) Copyright 2003, Texas Instruments, Inc
# ******************************************************************************

# Flash Driver

ifeq	($(BOARD), AR7DB)
SRCS_FLASH_C = flashop_amd_16.c
endif
ifeq	($(BOARD), AR7RD)
SRCS_FLASH_C = flashop_amd_16.c
endif
ifeq	($(BOARD), AR7VDB)
SRCS_FLASH_C = flashop_istrata_16.c
endif
ifeq	($(BOARD), EVM3)
SRCS_FLASH_C = flashop_istrata_32.c
endif
ifeq	($(BOARD), SEAD2)
SRCS_FLASH_C = flashop_istrata_32.c
endif
ifeq	($(BOARD), TNETV1050VDB)
SRCS_FLASH_C = flashop_atmel_32.c
endif
ifeq	($(BOARD), TNETV1050SDB)
SRCS_FLASH_C = flashop_ic3.c
endif
ifeq	($(BOARD), TNETV1050RDB)
SRCS_FLASH_C = flashop_ic3_16.c
endif
ifeq	($(BOARD), TNETV1060SDB_WR)
SRCS_FLASH_C = flashop_ic3.c
endif
ifneq ($(filter TNETC%, $(BOARD)),)
SRCS_FLASH_C = flashop_is1050_16.c
endif
ifeq	($(BOARD), TNETC401B)	# TNETC401B uses a different flash op.
SRCS_FLASH_C = flashop_istrata_16.c
endif
ifeq	($(BOARD), AR7WRD)
SRCS_FLASH_C = flashop_amd_16.c
endif
ifeq	($(BOARD), WLAN)
SRCS_FLASH_C = flashop_is1050_16.c
endif
ifeq	($(BOARD), TNETV1020VDB)
SRCS_FLASH_C = flashop_istrata_16.c
endif
ifeq	($(BOARD), TNETWA115VAG)
SRCS_FLASH_C = flashop_is1050_16.c
endif
ifeq	($(BOARD), AR7VWi)
SRCS_FLASH_C = flashop_amd_16.c
endif
ifeq	($(BOARD), AR7VW)
SRCS_FLASH_C = flashop_amd_16.c
endif
ifeq	($(BOARD), AR7Wi)
SRCS_FLASH_C = flashop_amd_16.c
endif
ifeq	($(BOARD), AR7V)
SRCS_FLASH_C = flashop_amd_16.c
endif
ifeq	($(BOARD), AR7L0)
SRCS_FLASH_C = flashop_amd_16.c
endif
ifeq	($(BOARD), TNETC4602MF)
SRCS_FLASH_C = flashop_is1050_16.c
endif
ifeq	($(BOARD), TNETC430)
SRCS_FLASH_C = flashop_is1050_16.c
endif
ifeq	($(BOARD), TNETC730)
SRCS_FLASH_C = flashop_amd_16.c
endif

