#!/bin/sh
# ------------------------------------------------------------
# RouterTech script to start TinyProxy with transparent filtering
# (c)2007-2008, RouterTech
# Author: TheChief
# Last amended: 15 July 2008
#
# ------------------------------------------------------------

# get the IPA to use as the filter IP
theip=$(getenv IPA)

# test for empty values
if test "$theip" = "" ; then
   echo "The IPA variable does not exist. Using 192.168.1.1 ..."
   theip=192.168.1.1
fi

# set up iptables
iptables -I PREROUTING -t nat -i br+ -p tcp -j REDIRECT --dport 80 --to-port 8888 --dst ! $theip

# call tinyproxy
/usr/local/bin/tinyproxy "$@"

