/* UPnP Device Main Module */

#include "ILibParsers.h"
#include "UPnPMicroStack.h"
#include "ILibWebServer.h"
#include "ILibAsyncSocket.h"

/*****************Added by Srikiran************/
#include <signal.h>
#include <stdio.h>
#include <malloc.h>
#include <memory.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include "ipcon.h"
#include "portmap.h"
#include "pmlist.h"
#define LAN 0
#define WAN 1
#define MAX_INTERFACES 2 /* 1 LAN and 1 WAN */

#define EXTIP_CHANGED 1
#define EXTIP_SAME 0


struct IPCon *int_ipcon;
struct IPCon *ext_ipcon;
long int startup_time;
struct PortMapList	m_list;
char PhysicalLinkStatus[15];
int GateGetPhysicalLinkStatus(char *LinkStatus);
void UPnPPhysicalLinkStatusMonitor(void *data);
/*****************Added by Srikiran************/

void *UPnPmicroStackChain;
void *UPnPmicroStack;

void *UPnPMonitor;

int UPnPIPAddressList[MAX_INTERFACES];

int ext_ip_change;

void UPnPOSInfo1_MagicOn(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPOSInfo1_MagicOn();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* Srikiran Notes: 
	 *	Nothing to do as per the previous implementation. */
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_OSInfo1_MagicOn(upnptoken);
}

int GateGetPhysicalLinkStatus(char *LinkStatus)
{
   FILE *fd;
   int retval;
   char buffer[100];

   fd=fopen("/proc/avalanche/avsar_modem_training", "r");
   if(!fd)
   {
       //printf("Error: Unable to open DSL proc entry\n");
       return -1;
   }
   retval = read (fileno(fd), (void *)buffer, sizeof (buffer));
   if (retval < 0)
   {
   	//printf("Error: Unable to read the DSL proc entry");
      fclose(fd);
      return -1;
   }
   fclose(fd);
	/* retval is modulation type, Linkstatus is status of the link */
   sscanf (buffer, "%s %d", LinkStatus, &retval);
	if (strcmp (LinkStatus, "SHOWTIME") == 0)
			  strcpy (LinkStatus, "Up");
	else
			  strcpy (LinkStatus, "Down");
	return 0;
}

void UPnPWANCommonInterfaceConfig_GetCommonLinkProperties(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 */
   FILE *fd;
   int retval;
   char *pbuff;
   char *pos;
	unsigned int UpstreamMaxBitRate = 0, DownstreamMaxBitRate = 0;
	char LinkStatus[15] = "Down";

   pbuff=(char *) malloc(2*1024);
   if(!pbuff)
   {
      printf("Error: Malloc Failure\n");
		UPnPResponse_Error(upnptoken,501,"Action Failed");
      return;
   }

   fd=fopen("/proc/avalanche/avsar_modem_stats", "r");
   if(!fd)
   {
      //printf("Error: Unable to open DSL proc entry\n");
		UPnPResponse_Error(upnptoken,501,"Action Failed");
      return;
   }
   fread(pbuff, sizeof(char), 2*1024*sizeof(char), fd);
   fclose(fd);

   pos=strstr(pbuff, "US Connection Rate:");
   pos += strlen("US Connection Rate:");
   if(pos)
	{
		retval = sscanf(pos," %u", &UpstreamMaxBitRate);
      printf("retval = %d, upstream = %u", retval, UpstreamMaxBitRate);
   }
   pos=strstr(pbuff, "DS Connection Rate:");
   pos += strlen("DS Connection Rate:");
   if(pos)
	{
		retval = sscanf(pos," %u", &DownstreamMaxBitRate );
      printf("retval = %d, downstream = %u", retval, DownstreamMaxBitRate );
   }
   free(pbuff);

	retval = GateGetPhysicalLinkStatus(LinkStatus);
   if (retval < 0)
   {
		UPnPResponse_Error(upnptoken,501,"Action Failed");
      return;
   }

	printf("Invoke: UPnPWANCommonInterfaceConfig_GetCommonLinkProperties();\r\n");
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANCommonInterfaceConfig_GetCommonLinkProperties(upnptoken,"DSL", UpstreamMaxBitRate*1000, 
						 DownstreamMaxBitRate*1000, 
						 LinkStatus);
	//UPnPResponse_WANCommonInterfaceConfig_GetCommonLinkProperties(upnptoken,"Cable", 131072, 614400, "Up");
}

void UPnPWANCommonInterfaceConfig_GetTotalBytesReceived(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 */
	char dev[15];
   char *iface;
   FILE *stream;
   unsigned int bytes=0,total=0;

	printf("Invoke: UPnPWANCommonInterfaceConfig_GetTotalBytesReceived();\r\n");

	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* Read received from /proc */
   stream = fopen ( "/proc/net/dev", "r" );
   if ( stream != NULL )
   {
		iface=IPCon_GetIfName(ext_ipcon);
		
		while ( getc ( stream ) != '\n' );
		while ( getc ( stream ) != '\n' );

		while ( !feof( stream ) )
		{
			fscanf ( stream, "%[^:]:%u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u\n", dev, &bytes );
			if ( strcmp ( dev, iface )==0 )
					  total += bytes;
      }
		fclose ( stream );
   }
	else
	{
		total=1;
	}
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANCommonInterfaceConfig_GetTotalBytesReceived(upnptoken,total);
}

void UPnPWANCommonInterfaceConfig_GetTotalBytesSent(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 */
	char dev[15];
   char *iface;
   FILE *stream;
   unsigned int bytes=0,total=0;

	printf("Invoke: UPnPWANCommonInterfaceConfig_GetTotalBytesSent();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */

	/* Read sent from /proc */
	stream = fopen ( "/proc/net/dev", "r" );
	if ( stream != NULL )
	{
		iface=IPCon_GetIfName(ext_ipcon);
		while ( getc ( stream ) != '\n' );
		while ( getc ( stream ) != '\n' );

		while ( !feof( stream ) )
		{
			fscanf ( stream, "%[^:]:%*u %*u %*u %*u %*u %*u %*u %*u %u %*u %*u %*u %*u %*u %*u %*u\n", dev, &bytes );
			if ( strcmp ( dev, iface )==0 )
				total += bytes;
		}
		fclose ( stream );
	}
	else
	{
		total=1;
	}
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANCommonInterfaceConfig_GetTotalBytesSent(upnptoken,total);
}

void UPnPWANCommonInterfaceConfig_GetTotalPacketsReceived(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 */
	char dev[15];
   char *iface;
   FILE *stream;
   unsigned int pkt=0, total=0;

	printf("Invoke: UPnPWANCommonInterfaceConfig_GetTotalPacketsReceived();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */

   /* Read sent from /proc */
	stream = fopen ( "/proc/net/dev", "r" );
	
	if ( stream != NULL )
	{
			  iface=IPCon_GetIfName(ext_ipcon);
			  while ( getc ( stream ) != '\n' );
			  while ( getc ( stream ) != '\n' );

			  while ( !feof( stream ) )
			  {
						 fscanf ( stream, "%[^:]:%*u %u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u %*u\n", dev, &pkt );
						 if ( strcmp ( dev, iface )==0 )
									total += pkt;
			  }
			  fclose ( stream );
	}
	else
	{
			  total=1;
	}
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANCommonInterfaceConfig_GetTotalPacketsReceived(upnptoken,total);
}

void UPnPWANCommonInterfaceConfig_GetTotalPacketsSent(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 */
	char dev[15];
   char *iface;
   FILE *stream;
   unsigned int pkt=0, total=0;

	printf("Invoke: UPnPWANCommonInterfaceConfig_GetTotalPacketsSent();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */

   /* Read sent from /proc */
   stream = fopen ( "/proc/net/dev", "r" );
   if ( stream != NULL )
   {
		iface=IPCon_GetIfName(ext_ipcon);
      while ( getc ( stream ) != '\n' );
      while ( getc ( stream ) != '\n' );

      while ( !feof( stream ) )
      {
			fscanf ( stream, "%[^:]:%*u %*u %*u %*u %*u %*u %*u %*u %*u %u %*u %*u %*u %*u %*u %*u\n", dev, &pkt );
         if ( strcmp ( dev, iface )==0 )
         	total += pkt;
		}
      fclose ( stream );
	}
   else
   {
   	total=1;
   }
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANCommonInterfaceConfig_GetTotalPacketsSent(upnptoken,total);
}

int chkIPADDRstring(char * addr) {
        struct in_addr dmy;
        return inet_aton(addr, &dmy);
}

void UPnPWANIPConnection_AddPortMapping(UPnPSessionToken upnptoken,char* NewRemoteHost,unsigned short NewExternalPort,char* NewProtocol,unsigned short NewInternalPort,char* NewInternalClient,int NewEnabled,char* NewPortMappingDescription,unsigned int NewLeaseDuration)
{
	/* Added by Srikiran
	 */
	int result=0;
	char *address = NULL;
	struct PortMap		*itr;
	struct PortMap		*itr_work;
	printf("Invoke: UPnPWANIPConnection_AddPortMapping(%s,%u,%s,%u,%s,%d,%s,%u);\r\n",NewRemoteHost,NewExternalPort,NewProtocol,NewInternalPort,NewInternalClient,NewEnabled,NewPortMappingDescription,NewLeaseDuration);
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */

	address = IPCon_GetIpAddrStr(ext_ipcon);
	if (!address)
	{
		UPnPResponse_Error(upnptoken,501,"Action Failed");
		return;
	}

	if (chkIPADDRstring(NewInternalClient) != 0)
	{
		for (itr = m_list.m_pmap; itr;)
		{
			if ((itr->m_ExternalPort == NewExternalPort) 
				&& (strcmp(itr->m_PortMappingProtocol, NewProtocol) == 0) 
				&& (strcmp(itr->m_InternalClient, NewInternalClient) == 0))
			{
				PortMap_delPortForward(itr->m_PortMappingProtocol, 
					itr->m_RemoteHost,
					itr->m_ExternalIP,
					itr->m_ExternalPort, itr->m_InternalClient,
					itr->m_InternalPort);
				itr_work = itr;
				NODE_DEL(m_list.m_pmap, itr_work);
				itr = itr_work->prev;
				if(!itr)
					itr = m_list.m_pmap;
				free(itr);
			} else {
				itr = itr->next;
			}
		}
		result = PortMapAdd(&(m_list), NewRemoteHost, NewProtocol, address, NewExternalPort, 
			NewInternalClient, NewInternalPort, NewEnabled, 
			NewPortMappingDescription, NewLeaseDuration);
		if (result == 1)
		{
			int size=0;
			for (itr = m_list.m_pmap; itr; itr=itr->next) {
				size++;
			}
			UPnPSetState_WANIPConnection_PortMappingNumberOfEntries(UPnPmicroStack,size);
			UPnPResponse_WANIPConnection_AddPortMapping(upnptoken);
		}
		else
		{
			if (result==718)
			{
//				syslog(LOG_ERR,"Failure in GateDeviceAddPortMapping: RemoteHost: %s Prot:%d ExtPort: %d Int: %s.%d\n", 	remote_host,prt, atoi(ext_port),int_ip, atoi(int_port));
				UPnPResponse_Error(upnptoken,718,"ConflictInMappingEntry");
			}
			/* This error condition to be supported in above f() */
			if (result==501)
			{
				UPnPResponse_Error(upnptoken,501,"Action Failed");
			}
		}
	}
	else
	{
//	        syslog(LOG_ERR, "Failure in GateDeviceAddPortMapping: Invalid NewInternalClient=%s\n",int_ip);
		UPnPResponse_Error(upnptoken,402,"Invalid Args");
	}

	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	if (address) free(address);
}

void UPnPWANIPConnection_DeletePortMapping(UPnPSessionToken upnptoken,char* NewRemoteHost,unsigned short NewExternalPort,char* NewProtocol)
{
	/* Added by Srikiran
	 */
	int result=0;
	struct PortMap	*itr;
	printf("Invoke: UPnPWANIPConnection_DeletePortMapping(%s,%u,%s);\r\n",NewRemoteHost,NewExternalPort,NewProtocol);

	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	result=PortMapDelete(&(m_list), NewProtocol, NewExternalPort);
	if (result==1)
	{
		int size=0;
		for (itr = m_list.m_pmap; itr; itr=itr->next) {
			size++;
		}
//		syslog(LOG_DEBUG, "DeletePortMap: Proto:%s Port:%s\n",proto, ext_port);
		UPnPSetState_WANIPConnection_PortMappingNumberOfEntries(UPnPmicroStack,size);
		UPnPResponse_WANIPConnection_DeletePortMapping(upnptoken);
	}
	else
	{
//		syslog(LOG_DEBUG, "Failure in GateDeviceDeletePortMapping: DeletePortMap: Proto:%s Port:%s\n",proto, ext_port);
		UPnPResponse_Error(upnptoken,714,"NoSuchEntryInArray");
	}
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
}

void UPnPWANIPConnection_ForceTermination(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 * As per previous implemention, there is no functionality support for this action.	
	 */
	printf("Invoke: UPnPWANIPConnection_ForceTermination();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANIPConnection_ForceTermination(upnptoken);
}

void UPnPWANIPConnection_GetConnectionTypeInfo(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 */
	printf("Invoke: UPnPWANIPConnection_GetConnectionTypeInfo();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANIPConnection_GetConnectionTypeInfo(upnptoken,"IP_Routed","IP_Routed");
}

void UPnPWANIPConnection_GetExternalIPAddress(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 */
	char *ip_address;
	
	printf("Invoke: UPnPWANIPConnection_GetExternalIPAddress();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	ip_address = IPCon_GetIpAddrStr(ext_ipcon);	
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	if (ip_address)
	{
		UPnPResponse_WANIPConnection_GetExternalIPAddress(upnptoken, ip_address);
	 	free(ip_address);
	}
	else
	{
		UPnPResponse_Error(upnptoken,501,"Action Failed");
	}
	
}

void UPnPWANIPConnection_GetGenericPortMappingEntry(UPnPSessionToken upnptoken,unsigned short NewPortMappingIndex)
{
	/* Added by Srikiran
	 */
	int i = 0;
	int action_succeeded = 0;
	struct PortMap	*itr;
	printf("Invoke: UPnPWANIPConnection_GetGenericPortMappingEntry(%u);\r\n",NewPortMappingIndex);

	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	for (itr = m_list.m_pmap; itr; itr=itr->next,i++)
	{
		if (i == NewPortMappingIndex)
		{
			UPnPResponse_WANIPConnection_GetGenericPortMappingEntry(upnptoken,itr->m_RemoteHost,
			itr->m_ExternalPort,itr->m_PortMappingProtocol,itr->m_InternalPort,itr->m_InternalClient,
			itr->m_PortMappingEnabled,itr->m_PortMappingDescription,itr->m_PortMappingLeaseDuration);	
			action_succeeded = 1;
		}
	}
	
	if (!action_succeeded)
		UPnPResponse_Error(upnptoken,713,"SpecifiedArrayIndexInvalid");
}

void UPnPWANIPConnection_GetNATRSIPStatus(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 */
	printf("Invoke: UPnPWANIPConnection_GetNATRSIPStatus();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */

	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANIPConnection_GetNATRSIPStatus(upnptoken,0,1);
}

void UPnPWANIPConnection_GetSpecificPortMappingEntry(UPnPSessionToken upnptoken,char* NewRemoteHost,unsigned short NewExternalPort,char* NewProtocol)
{
	/* Added by Srikiran
	 */
	int action_succeeded = 0;
	struct PortMap		*itr;
	printf("Invoke: UPnPWANIPConnection_GetSpecificPortMappingEntry(%s,%u,%s);\r\n",NewRemoteHost,NewExternalPort,NewProtocol);

	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	for (itr = m_list.m_pmap; itr; itr=itr->next)
	{
		if (((itr->m_ExternalPort == NewExternalPort) && (strcmp(itr->m_RemoteHost,NewRemoteHost) == 0) && 
		(strcmp(itr->m_PortMappingProtocol,NewProtocol) == 0)))
		{
			UPnPResponse_WANIPConnection_GetSpecificPortMappingEntry(upnptoken,
				itr->m_InternalPort, 
				itr->m_InternalClient,
				itr->m_PortMappingEnabled,
				itr->m_PortMappingDescription,
				itr->m_PortMappingLeaseDuration);
			action_succeeded = 1;
		}
	}
	if (!action_succeeded)
	{
		UPnPResponse_Error(upnptoken,714,"NoSuchEntryInArray");
	}
}

void UPnPWANIPConnection_GetStatusInfo(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 */
	long int uptime;

	printf("Invoke: UPnPWANIPConnection_GetStatusInfo();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	uptime = (time(NULL) - startup_time);

	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANIPConnection_GetStatusInfo(upnptoken,"Connected", "ERROR_NONE", uptime);
}

void UPnPWANIPConnection_RequestConnection(UPnPSessionToken upnptoken)
{
	/* Added by Srikiran
	 * As per the previous implementation, there is no functionality support for this action.
	 */
	printf("Invoke: UPnPWANIPConnection_RequestConnection();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANIPConnection_RequestConnection(upnptoken);
}

void UPnPWANIPConnection_SetConnectionType(UPnPSessionToken upnptoken,char* NewConnectionType)
{
	/* Added by Srikiran
	 * As per the previous implementation, there is no functionality support for this action.
	 */
	printf("Invoke: UPnPWANIPConnection_SetConnectionType(%s);\r\n",NewConnectionType);
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* UPnPResponse_Error(upnptoken,404,"Method Not Implemented"); */
	UPnPResponse_WANIPConnection_SetConnectionType(upnptoken);
}

void UPnPPresentationRequest(void* upnptoken, struct packetheader *packet)
{
	/* Added by Srikiran
	 */
	char *address = NULL;
	char *cResponseBuf = NULL;

	address = IPCon_GetIpAddrStr(int_ipcon);
	cResponseBuf = (char *) malloc (100);

	if (cResponseBuf == NULL) 
	{
		printf("Allocation of Response Buffer Failed!\n");
		return;
	}

	memset(cResponseBuf, 0, 100);

	sprintf(cResponseBuf, "<meta HTTP-EQUIV=\"REFRESH\" content=\"0;\r\n url=http://%s\">", address);

	printf("UPnP Presentation Request: %s %s\r\n", packet->Directive,packet->DirectiveObj);
	printf("HOST: %x\r\n",UPnPGetLocalInterfaceToHost(upnptoken));
	printf("\nResponse Buffer: %s\n",cResponseBuf);
	printf("Response Buffer Length: %d\n",strlen(cResponseBuf));

	ILibWebServer_Send_Raw(upnptoken, cResponseBuf, strlen(cResponseBuf), 1, 1);

	if (address) free(address);
	if (cResponseBuf) free(cResponseBuf);
}

void UPnPIPAddressMonitor(void *data)
{
	char lan_ip_address[16];
	char *address;
	struct in_addr in;
	
	/* Modified by Srikiran - To limit UPnP support on the command line specified interfaces only!
	 * 12/20 - Changed the IPAddressList and comparison
	 */
	
	address = IPCon_GetIpAddrStr(int_ipcon);
                                                                                                                             
        if (address)
        {
                strcpy(lan_ip_address, address);
                inet_aton(lan_ip_address, &in);
                                                                                                                             
		if (UPnPIPAddressList[LAN] != in.s_addr)
	{
		UPnPIPAddressListChanged(UPnPmicroStack);
			UPnPIPAddressList[LAN] = in.s_addr;
		}
                                                                                                                             
		free(address);
	}

	if (ext_ip_change == EXTIP_CHANGED)
	{
		address = IPCon_GetIpAddrStr(ext_ipcon);

		if (address)	
		{
			UPnPSetState_WANIPConnection_ExternalIPAddress(UPnPmicroStack,address);
			ext_ip_change = EXTIP_SAME;
			free(address);
		}
	}
	
	ILibLifeTime_Add(UPnPMonitor,NULL,4,&UPnPIPAddressMonitor,NULL);
}
void BreakSink(int s)
{
	ILibStopChain(UPnPmicroStackChain);
}

/* Signal Handler for SIGUSR1 (16) */

static void ExtIPAddrChange(int s)
{
	char *address;
	struct in_addr in;
	char wan_ip_address[16];
	FILE *log;

	log = fopen("/var/tmp/upnp_sig","a+");
	fprintf(log, "UPnP : Caught Signal %d\n",s);

	address = IPCon_GetIpAddrStr(ext_ipcon);
	if (address)
	{
		strcpy(wan_ip_address, address);
		inet_aton(wan_ip_address, &in);
		if (UPnPIPAddressList[WAN] != in.s_addr)
		{
			
			fprintf(log, "UPnP : Address changed : %s\n",address);
			fclose(log);
			ext_ip_change = EXTIP_CHANGED;	
			UPnPIPAddressList[WAN] = in.s_addr;
		}

		free(address);
	}
}

void UPnPPhysicalLinkStatusMonitor(void *data)
{
	char LinkStatus[15] = "Down" ;
	GateGetPhysicalLinkStatus(LinkStatus);
	if (strcmp(LinkStatus, PhysicalLinkStatus) != 0) 
	{
		strcpy (PhysicalLinkStatus, LinkStatus);
		UPnPSetState_WANCommonInterfaceConfig_PhysicalLinkStatus(UPnPmicroStack, PhysicalLinkStatus);
	}
	ILibLifeTime_Add(UPnPMonitor,NULL,5,&UPnPPhysicalLinkStatusMonitor,NULL);
}
		  
int main(int argc, char** argv)
{
	char lan_ip_address[16];
	char wan_ip_address[16];
	char *address;
	struct in_addr in;
	struct sigaction sa;/* Signal Handler for SIGUSER1(16) */

	/* Modified by Srikiran - 
	 * 1. By default, the notify cycles is 1800 as per spec, can be changed thru cmdline args
	 * 2. To limit UPnP support on the command line specified interfaces only.
	 * 3. Destruction of the rules created by Control Points during closure.
	 * 4. Updated UDN fromt the previous implementation.
	 */
	int iNotifyCyclesSecs = 1800;

	if (argc < 3)
	{
		printf("Usage: upnpd <external ifname> <internal ifname> [NotifyCycleTime(1800)]\n");
		printf("Example: upnpd ppp0 eth0\n");
		printf("Example: upnpd eth1 eth0 60\n");
		exit(0);
	}
	if (argc == 4) 
	{
		/* Get the Broadcast time */
		iNotifyCyclesSecs = atoi(argv[3]); 
	}
	printf("NotifyCycleSecs - %d\n", iNotifyCyclesSecs);

	if (geteuid()) {
		fprintf(stderr, "upnpd must be run as root\n");
		exit(EXIT_FAILURE);
	}
        if ((chdir("/")) < 0)
        {
                perror("Error setting root directory");
                exit(EXIT_FAILURE);
        }
        umask(0);

	int_ipcon = (struct IPCon *)malloc(sizeof(struct IPCon *));
	IPCon_Construct(int_ipcon, argv[2]);
	address = IPCon_GetIpAddrStr(int_ipcon);
	strcpy(lan_ip_address, address);
	if (address) free(address);

	ext_ipcon = (struct IPCon *)malloc(sizeof(struct IPCon *));
	IPCon_Construct(ext_ipcon, argv[1]);

	bzero((void*)&m_list, sizeof(struct PortMapList));

	UPnPmicroStackChain = ILibCreateChain();
	
	/* TODO: Each device must have a unique device identifier (UDN) */
	UPnPmicroStack = UPnPCreateMicroStack(UPnPmicroStackChain,"Texas Instruments DSL router","WANDevice","WANConnectionDevice","160a0200-ac90-4b05-8adf-f5ccc5a5ebaa","0000001",iNotifyCyclesSecs/*1800*/,UPNP_WEB_SERVER_PORT);
//	UPnPmicroStack = UPnPCreateMicroStack(UPnPmicroStackChain,"Texas Instruments DSL router","WANDevice","WANConnectionDevice","f843ec87-a6b6-11d9-9023-000ea6158e44","0000001",60, 80);
	UPnPFP_PresentationPage=&UPnPPresentationRequest;
	UPnPFP_OSInfo1_MagicOn=&UPnPOSInfo1_MagicOn;
	UPnPFP_WANCommonInterfaceConfig_GetCommonLinkProperties=&UPnPWANCommonInterfaceConfig_GetCommonLinkProperties;
	UPnPFP_WANCommonInterfaceConfig_GetTotalBytesReceived=&UPnPWANCommonInterfaceConfig_GetTotalBytesReceived;
	UPnPFP_WANCommonInterfaceConfig_GetTotalBytesSent=&UPnPWANCommonInterfaceConfig_GetTotalBytesSent;
	UPnPFP_WANCommonInterfaceConfig_GetTotalPacketsReceived=&UPnPWANCommonInterfaceConfig_GetTotalPacketsReceived;
	UPnPFP_WANCommonInterfaceConfig_GetTotalPacketsSent=&UPnPWANCommonInterfaceConfig_GetTotalPacketsSent;
	UPnPFP_WANIPConnection_AddPortMapping=&UPnPWANIPConnection_AddPortMapping;
	UPnPFP_WANIPConnection_DeletePortMapping=&UPnPWANIPConnection_DeletePortMapping;
	UPnPFP_WANIPConnection_ForceTermination=&UPnPWANIPConnection_ForceTermination;
	UPnPFP_WANIPConnection_GetConnectionTypeInfo=&UPnPWANIPConnection_GetConnectionTypeInfo;
	UPnPFP_WANIPConnection_GetExternalIPAddress=&UPnPWANIPConnection_GetExternalIPAddress;
	UPnPFP_WANIPConnection_GetGenericPortMappingEntry=&UPnPWANIPConnection_GetGenericPortMappingEntry;
	UPnPFP_WANIPConnection_GetNATRSIPStatus=&UPnPWANIPConnection_GetNATRSIPStatus;
	UPnPFP_WANIPConnection_GetSpecificPortMappingEntry=&UPnPWANIPConnection_GetSpecificPortMappingEntry;
	UPnPFP_WANIPConnection_GetStatusInfo=&UPnPWANIPConnection_GetStatusInfo;
	UPnPFP_WANIPConnection_RequestConnection=&UPnPWANIPConnection_RequestConnection;
	UPnPFP_WANIPConnection_SetConnectionType=&UPnPWANIPConnection_SetConnectionType;
	
	
	/* All evented state variables MUST be initialized before UPnPStart is called. */
	//UPnPSetState_WANCommonInterfaceConfig_PhysicalLinkStatus(UPnPmicroStack,IPCon_GetIfStatStr(ext_ipcon));
	GateGetPhysicalLinkStatus(PhysicalLinkStatus);
	UPnPSetState_WANCommonInterfaceConfig_PhysicalLinkStatus(UPnPmicroStack, PhysicalLinkStatus);
	UPnPSetState_WANIPConnection_PossibleConnectionTypes(UPnPmicroStack,"IP_Routed");
	UPnPSetState_WANIPConnection_X_Name(UPnPmicroStack,"Local Area Connection");
	UPnPSetState_WANIPConnection_PortMappingNumberOfEntries(UPnPmicroStack,0);
	address = IPCon_GetIpAddrStr(ext_ipcon);
	if (address) 
	{
		UPnPSetState_WANIPConnection_ExternalIPAddress(UPnPmicroStack,address);
		strcpy(wan_ip_address, address);
		free(address);
	} 
	else
	{
		UPnPSetState_WANIPConnection_ExternalIPAddress(UPnPmicroStack,"Not Found");
	}
	UPnPSetState_WANIPConnection_ConnectionStatus(UPnPmicroStack,"Connected");
	
	printf("Intel MicroStack 1.0 \r\n\r\n");
	
	UPnPMonitor = ILibCreateLifeTime(UPnPmicroStackChain);

	inet_aton(lan_ip_address, &in);
	UPnPIPAddressList[LAN] = in.s_addr;
        
	inet_aton(wan_ip_address, &in);
        UPnPIPAddressList[WAN] = in.s_addr;
	ext_ip_change = EXTIP_SAME;

	startup_time = time(NULL);

	ILibLifeTime_Add(UPnPMonitor,NULL,4,&UPnPIPAddressMonitor,NULL);
	
	ILibLifeTime_Add(UPnPMonitor,NULL,5,&UPnPPhysicalLinkStatusMonitor,NULL);
	
	signal(SIGINT,BreakSink);

	/* Set the sigaction handler */
	sa.sa_handler = ExtIPAddrChange;
	sa.sa_flags = 0;

	/* Call the function to set the handler */	
	sigaction( SIGUSR1, &sa, NULL);

	ILibStartChain(UPnPmicroStackChain);
	
	if (int_ipcon) 
	{
			  IPCon_Destruct(int_ipcon);
			  free(int_ipcon);
	}
	if (ext_ipcon) 
	{
			  IPCon_Destruct(ext_ipcon);
			  free(ext_ipcon);
	}
	PortMapList_Destruct(&m_list);
	return 0;
}

